#ifndef __SP_NEWGAME
#define __SP_NEWGAME

#include "stk/stk.h"
#include "motor3d/stars.h"
#include "motor3d/planets.h"
#include "motor3d/loadgl.h"
#include "physique/sp_car.h"
#include "physique/sp_circuit.h"
#include "motor3d/sp_obj.h"



class Light0:public Sp_Light
{
public:
        // constructor
    Light0(char *name, Sp_Adm *adm, Sp_Obj *obj);
        // light
    void Light();
        // parameter
    float ambient[4]; 
    float diffuse[4]; 
    float position0[4];
    float front_mat_shininess[1];
    float front_mat_specular[4];
    float front_mat_diffuse[4];
    float lmodel_ambient[4];
    float lmodel_twoside[1];
};


class Sp_NewGame: public Stk_Prog, public Stk_Timer
{
public:
    Sp_NewGame(Stk_Prog *);
    virtual ~Sp_NewGame();
    void GetFocus();
    void MessageReceived(Stk_Message *);  
    int Loop();
    

        // some usefull variables
    Sp_Adm *gest3d;
    Sp_Obj_stars *etoiles;
    Sp_View *objf;
    Sp_View *objf2;
    Sp_Car *objf3;
    Sp_View *cam_car;
    Sp_Obj_gl *circuitnew;
    Sp_Load_CircuitC *circuitphy;

        //
    Light0 *light0;
    
        // time values
    long start;
    long last;
    long current;

    
private:
    int quit;
        // font
    Stk_Font *font;
    Stk_Gui_Window *window;
    Stk_Gui_Static *widget_static;
};



#endif
